/*!	@file
	@brief Ruby}N

	@author Sakura-Editor collaborators
	@date 2013.12.16
*/
/*
	Copyright (C) 2013, Sakura-Editor collaborators

	This software is provided 'as-is', without any express or implied
	warranty. In no event will the authors be held liable for any damages
	arising from the use of this software.

	Permission is granted to anyone to use this software for any purpose, 
	including commercial applications, and to alter it and redistribute it 
	freely, subject to the following restrictions:

		1. The origin of this software must not be misrepresented;
		   you must not claim that you wrote the original software.
		   If you use this software in a product, an acknowledgment
		   in the product documentation would be appreciated but is
		   not required.

		2. Altered source versions must be plainly marked as such, 
		   and must not be misrepresented as being the original software.

		3. This notice may not be removed or altered from any source
		   distribution.
*/

#ifndef _CRUBYMACROMGR_H_
#define _CRUBYMACROMGR_H_

#include <Windows.h>
#include "CKeyMacroMgr.h"
#include "CRuby.h"

/** Ruby}N
*/
class CRubyMacroMgr: public CMacroManagerBase
{
protected:
	CNativeW			m_cBuffer;	//!< s}NR[h
	static class CRuby	m_cRuby;	//!< Ruby DLLANZXNX

public:
	CRubyMacroMgr();
	virtual ~CRubyMacroMgr();

	virtual bool ExecKeyMacro(class CEditView* pcEditView, int flags) const;	//!< Ruby}N̎s
	virtual BOOL LoadKeyMacro(HINSTANCE hInstance, const TCHAR* lpszPath);		//!< }Nt@Cǂݍ
	virtual BOOL LoadKeyMacroStr(HINSTANCE hInstance, const TCHAR* lpszCode);	//!< }N𕶎񂩂ǂݍ

	static CMacroManagerBase* Creator(const TCHAR* ext);
	static void declare(void);
};

#endif	//_CRUBYMACROMGR_H_
